#!/bin/csh -f
#
# PyMOL startup script
#
# ==============================================================
# Set PYMOL_PATH to point at the correct location on your system
#
setenv PYMOL_PATH /scisoft/pxsoft/src/pymol-0.78/suse64/pymol-0.78
#
# ==============================================================
# (no changes usually required below here)
#
setenv PYMOL_EXTLIBPATH ${PYMOL_PATH}/ext/lib
#
# Tcl/Tk path
setenv TCL_LIBRARY $PYMOL_EXTLIBPATH/tcl8.0
#
# dynamic linking
# 
if ( $?LD_LIBRARY_PATH ) then
setenv LD_LIBRARY_PATH ${PYMOL_EXTLIBPATH}:${LD_LIBRARY_PATH}
else
setenv LD_LIBRARY_PATH ${PYMOL_EXTLIBPATH}
endif
#
# python modules
#
if ( $?PYTHONPATH ) then
setenv PYTHONPATH ${PYMOL_PATH}/modules:${PYMOL_EXTLIBPATH}/python1.5:${PYTHONPATH}
else
setenv PYTHONPATH ${PYMOL_PATH}/modules:${PYMOL_EXTLIBPATH}/python1.5
endif
#
#
#dbx $PYMOL_PATH/ext/bin/python 
#gdb $PYMOL_PATH/ext/bin/python 
$PYMOL_PATH/ext/bin/python $PYMOL_PATH/modules/launch_pymol.py $*

